﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace WC_MultiselectionWithShiftClick
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void ultraCombo1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            UltraGridColumn c = e.Layout.Bands[0].Columns.Add();

            ultraCombo1.Textbox.TextChanged += Textbox_TextChanged;

            c.Key = "Selected";
            c.Header.Caption = string.Empty;
            c.Header.CheckBoxVisibility = HeaderCheckBoxVisibility.Always;
            c.Hidden = true ;
            this.ultraCombo1.CheckedListSettings.CheckStateMember = "Selected";
            this.ultraCombo1.CheckedListSettings.ItemCheckArea = ItemCheckArea.Item;
            this.ultraCombo1.CheckedListSettings.EditorValueSource = Infragistics.Win.EditorWithComboValueSource.CheckedItems;
            this.ultraCombo1.CheckedListSettings.ListSeparator = " / ";
            this.ultraCombo1.DisplayMember = "Name";
            this.ultraCombo1.ValueMember = "ID";
            c.DataType = typeof(bool);
            e.Layout.Bands[0].Columns["ID"].Hidden = true;
        }

        void Textbox_TextChanged(object sender, EventArgs e)
        {
            if (ultraCombo1.Textbox.Text == String.Empty)
            {
                ultraCombo1.Textbox.Text = "Select All...";
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraCombo1.SetInitialValue("Select All...", "Select All...");
            DataTable dt = new DataTable();
            dt.Columns.Add("ID", typeof(int)).AutoIncrement = true;
            dt.Columns.Add("Name", typeof(string));

            dt.Rows.Add(new object[] { null, "One" });
            dt.Rows.Add(new object[] { null, "Two" });
            dt.Rows.Add(new object[] { null, "Three" });
            dt.Rows.Add(new object[] { null, "Four" });
            dt.Rows.Add(new object[] { null, "Five" });
            ultraCombo1.DataSource = dt;
        }

    }
}
